import router from "@/router";
import NProgress from "@/utils/nprogress";
import { useDictionaryStore } from "@/store/modules/dictionary";
import { getUserDicts } from "@/api/auth";
import { useSettingsStore, useUserStore } from "@/store";

export function setupPermission() {
  router.beforeEach(async (to, from, next) => {
    const userStore = useUserStore();
    NProgress.start();
    const isShow = inject("isShow");
    const route = useRoute();
    if (to.fullPath.substr(0, 10) == "/pro-steps") {
      next();
    } else {
      isShow.value = true;
    }
    const hasToken = localStorage.getItem("token");
    if (hasToken) {
      const dictStore = useDictionaryStore();
      dictStore.checkAllData();
      if (
        !dictStore.dicts.value ||
        JSON.stringify(dictStore.dicts.value) === "{}"
      ) {
        const res = await getUserDicts(dictStore.types);
        if (res.data) {
          dictStore.dicts = res?.data ?? [];
        }
      }
      next();
    } else {
      //自动登录
      const acountP = {
        userName: "admin",
        password: "123456",
        proCode: "TG28",
        orgId: "1",
        stationId: "67",
        stationType: "3",
      };

      await userStore
        .login(acountP)
        .then(() => {
          next(`pro-steps`);
        })
        .catch(() => {
          // getCaptcha();
        })
        .finally(() => {});
    }
  });

  router.afterEach(() => {
    const isShow = inject("isShow");
    const route = useRoute();
    //@ts-ignore
    if (isShow.value == true) {
      //@ts-ignore
      isShow.value = false;
    }
    NProgress.done();
  });
}
